/*

   HMG Sample
   
   Set / Cursor Positions
   
   Author : Bicahi Esgici
   
   2014 August
   
*/

#include <hmg.ch>

PROCEDURE Main()

   aGetFuncs :=   { 'HMG_SYS_DATA'          ,;     
                     'GetCursorPos (AW)'     ,;     
                     'GetCursorPos (DW)'     ,;     
                     'HMG_GetCursorPos (AW)' ,;     
                     'HMG_GetCursorPos (DW)' }     
   aSetFuncs  :=  {}
   aCPSources := {}
   
   AEVAL( aGetFuncs, { | c1 | AADD( aCPSources, { c1, 0, 0 } ),;
                              AADD( aSetFuncs, STRTRAN( c1, 'Get', 'Set' ) ) } )

   DEFINE WINDOW frmCursPoss ;
      ROW 0 ;
      COL 0 ;
      WIDTH 600 ;
      HEIGHT 420 ;
      TITLE 'Exploring new functions of HMG 3.3.1 -- 3 : New mouse functions' ; //   
      ON INIT NIL ; 
      MAIN
      
      ON KEY ESCAPE ACTION ThisWindow.Release
      
      @ 20, 140 FRAME frmGetdCursPoss ;
			WIDTH 330 ;
			HEIGHT 160 ;
         CAPTION "Get Cursor positions"
      
      @ 40, 150 GRID grdGetCursPoss ;
			WIDTH 310 ;
			HEIGHT 130 ;
			HEADERS { 'Function', 'Row','Col' } ;
			WIDTHS  { 200, 50, 50 } ;  
         ITEMS aCPSources ;  
         JUSTIFY { 0, 1, 1 } ;         
			VALUE 1 ;
         COLUMNCONTROLS { { 'TEXTBOX', 'CHARACTER' }, { 'TEXTBOX', 'NUMERIC', '9999' }, { 'TEXTBOX', 'NUMERIC', '9999'  } } ;
         CELLNAVIGATION 
       
      @ 200, 140 FRAME frmSetdCursPoss ;
			WIDTH 330 ;
			HEIGHT 120 ;
         CAPTION "Set Cursor positions" 
         
      @ 220, 150 LABEL    lblFunctions VALUE "Functions"   
      @ 220, 375 LABEL    lblRow       VALUE "Row"      
      @ 220, 425 LABEL    lblColumn    VALUE "Col"      
      @ 240, 150 COMBOBOX cmbFunctions WIDTH 180 ITEMS aSetFuncs VALUE 1  
      @ 240, 350 TEXTBOX  txbSetRow    WIDTH 50 NUMERIC VALUE 0 
      @ 240, 410 TEXTBOX  txbSetCol    WIDTH 50 NUMERIC VALUE 0 
      @ 280, 280 BUTTON   btnSet       CAPTION "Set" ACTION SetThisPos()
              
		DEFINE TIMER Timer_1 ;
		   INTERVAL 500 ;
		   ACTION UpdaGrid()
         
      DEFINE STATUSBAR 
         STATUSITEM "AW : Application Window; DW : Desktop Window"  WIDTH 600   
      END STATUSBAR      
      
   END WINDOW // frmCursPoss

   CENTER Window frmCursPoss

   ACTIVATE Window frmCursPoss
   
RETURN // CursPoss.Main()      

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE SetThisPos()

   LOCAL nFuncNo := frmCursPoss.cmbFunctions.Value ,;
         nCurRow := frmCursPoss.txbSetRow.Value ,;
         nCurCol := frmCursPoss.txbSetCol.Value 
   
   SWITCH nFuncNo   
      CASE 1                // HMG_SYS_DATA
         _HMG_SYSDATA [ 191 ] := nCurRow
         _HMG_SYSDATA [ 192 ] := nCurCol
         EXIT
      CASE 2                // SetCursorPos (AW)
         SetCursorPos( nCurRow + ThisWindow.Row + 30 , nCurCol + ThisWindow.Col + 8 )
         EXIT
      CASE 3                // SetCursorPos (DW)
         SetCursorPos( nCurRow, nCurCol )
         EXIT
      CASE 4                // HMG_SetCursorPos (AW)
         HMG_SetCursorPos( ThisWindow.Handle, nCurRow, nCurCol ) 
         EXIT
      CASE 5                // HMG_SetCursorPos (DW)
         HMG_SetCursorPos( , nCurRow, nCurCol ) 
   END SWITCH      
   

RETURN //SetThisPos()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE UpdaGrid()

   LOCAL nDCurRow, nDCurCol, nACurRow, nACurCol
   
   HMG_GetCursorPos( , @nDCurRow, @nDCurCol ) 
   HMG_GetCursorPos( ThisWindow.Handle, @nACurRow, @nACurCol ) 

   frmCursPoss.grdGetCursPoss.Cell( 1, 2 ):=  _HMG_SYSDATA [ 191 ]
   frmCursPoss.grdGetCursPoss.Cell( 1, 3 ):=  _HMG_SYSDATA [ 192 ]
   
   frmCursPoss.grdGetCursPoss.Cell( 2, 2 ):=  GetCursorPos()[ 1 ] - ThisWindow.Row - 30
   frmCursPoss.grdGetCursPoss.Cell( 2, 3 ):=  GetCursorPos()[ 2 ] - ThisWindow.Col - 8 
   
   frmCursPoss.grdGetCursPoss.Cell( 3, 2 ):=  GetCursorPos()[ 1 ]
   frmCursPoss.grdGetCursPoss.Cell( 3, 3 ):=  GetCursorPos()[ 2 ]
   
   frmCursPoss.grdGetCursPoss.Cell( 4, 2 ):=  nACurRow
   frmCursPoss.grdGetCursPoss.Cell( 4, 3 ):=  nACurCol
   
   frmCursPoss.grdGetCursPoss.Cell( 5, 2 ):=  nDCurRow
   frmCursPoss.grdGetCursPoss.Cell( 5, 3 ):=  nDCurCol  
   
   frmCursPoss.grdGetCursPoss.Refresh()
   
RETURN // UpdaGrid()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.
